import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataYandexIotCoreDeviceConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_device#device_id DataYandexIotCoreDevice#device_id}
    */
    readonly deviceId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_device#name DataYandexIotCoreDevice#name}
    */
    readonly name?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_device yandex_iot_core_device}
*/
export declare class DataYandexIotCoreDevice extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "yandex_iot_core_device";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/d/iot_core_device yandex_iot_core_device} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataYandexIotCoreDeviceConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataYandexIotCoreDeviceConfig);
    aliases(key: string): string | cdktf.IResolvable;
    get certificates(): string[];
    get createdAt(): string;
    get description(): string;
    private _deviceId?;
    get deviceId(): string;
    set deviceId(value: string);
    resetDeviceId(): void;
    get deviceIdInput(): string | undefined;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get passwords(): string[];
    get registryId(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=data-yandex-iot-core-device.d.ts.map