import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface IamServiceAccountIamMemberConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_member#member IamServiceAccountIamMember#member}
    */
    readonly member: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_member#role IamServiceAccountIamMember#role}
    */
    readonly role: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_member#service_account_id IamServiceAccountIamMember#service_account_id}
    */
    readonly serviceAccountId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_member#sleep_after IamServiceAccountIamMember#sleep_after}
    */
    readonly sleepAfter?: number;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_member yandex_iam_service_account_iam_member}
*/
export declare class IamServiceAccountIamMember extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_iam_service_account_iam_member";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/iam_service_account_iam_member yandex_iam_service_account_iam_member} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options IamServiceAccountIamMemberConfig
    */
    constructor(scope: Construct, id: string, config: IamServiceAccountIamMemberConfig);
    get id(): string;
    private _member?;
    get member(): string;
    set member(value: string);
    get memberInput(): string | undefined;
    private _role?;
    get role(): string;
    set role(value: string);
    get roleInput(): string | undefined;
    private _serviceAccountId?;
    get serviceAccountId(): string;
    set serviceAccountId(value: string);
    get serviceAccountIdInput(): string | undefined;
    private _sleepAfter?;
    get sleepAfter(): number;
    set sleepAfter(value: number);
    resetSleepAfter(): void;
    get sleepAfterInput(): number | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=iam-service-account-iam-member.d.ts.map