import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface LbNetworkLoadBalancerConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#description LbNetworkLoadBalancer#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#folder_id LbNetworkLoadBalancer#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#labels LbNetworkLoadBalancer#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#name LbNetworkLoadBalancer#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#region_id LbNetworkLoadBalancer#region_id}
    */
    readonly regionId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#type LbNetworkLoadBalancer#type}
    */
    readonly type?: string;
    /**
    * attached_target_group block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#attached_target_group LbNetworkLoadBalancer#attached_target_group}
    */
    readonly attachedTargetGroup?: LbNetworkLoadBalancerAttachedTargetGroup[] | cdktf.IResolvable;
    /**
    * listener block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#listener LbNetworkLoadBalancer#listener}
    */
    readonly listener?: LbNetworkLoadBalancerListener[] | cdktf.IResolvable;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#timeouts LbNetworkLoadBalancer#timeouts}
    */
    readonly timeouts?: LbNetworkLoadBalancerTimeouts;
}
export interface LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#path LbNetworkLoadBalancer#path}
    */
    readonly path?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#port LbNetworkLoadBalancer#port}
    */
    readonly port: number;
}
export declare function lbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsToTerraform(struct?: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference | LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions): any;
export declare class LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions | undefined;
    set internalValue(value: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions | undefined);
    private _path?;
    get path(): string;
    set path(value: string);
    resetPath(): void;
    get pathInput(): string | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    get portInput(): number | undefined;
}
export interface LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#port LbNetworkLoadBalancer#port}
    */
    readonly port: number;
}
export declare function lbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsToTerraform(struct?: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference | LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions): any;
export declare class LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions | undefined;
    set internalValue(value: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions | undefined);
    private _port?;
    get port(): number;
    set port(value: number);
    get portInput(): number | undefined;
}
export interface LbNetworkLoadBalancerAttachedTargetGroupHealthcheck {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#healthy_threshold LbNetworkLoadBalancer#healthy_threshold}
    */
    readonly healthyThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#interval LbNetworkLoadBalancer#interval}
    */
    readonly interval?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#name LbNetworkLoadBalancer#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#timeout LbNetworkLoadBalancer#timeout}
    */
    readonly timeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#unhealthy_threshold LbNetworkLoadBalancer#unhealthy_threshold}
    */
    readonly unhealthyThreshold?: number;
    /**
    * http_options block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#http_options LbNetworkLoadBalancer#http_options}
    */
    readonly httpOptions?: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckHttpOptions;
    /**
    * tcp_options block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#tcp_options LbNetworkLoadBalancer#tcp_options}
    */
    readonly tcpOptions?: LbNetworkLoadBalancerAttachedTargetGroupHealthcheckTcpOptions;
}
export declare function lbNetworkLoadBalancerAttachedTargetGroupHealthcheckToTerraform(struct?: LbNetworkLoadBalancerAttachedTargetGroupHealthcheck | cdktf.IResolvable): any;
export interface LbNetworkLoadBalancerAttachedTargetGroup {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#target_group_id LbNetworkLoadBalancer#target_group_id}
    */
    readonly targetGroupId: string;
    /**
    * healthcheck block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#healthcheck LbNetworkLoadBalancer#healthcheck}
    */
    readonly healthcheck: LbNetworkLoadBalancerAttachedTargetGroupHealthcheck[] | cdktf.IResolvable;
}
export declare function lbNetworkLoadBalancerAttachedTargetGroupToTerraform(struct?: LbNetworkLoadBalancerAttachedTargetGroup | cdktf.IResolvable): any;
export interface LbNetworkLoadBalancerListenerExternalAddressSpec {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#address LbNetworkLoadBalancer#address}
    */
    readonly address?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#ip_version LbNetworkLoadBalancer#ip_version}
    */
    readonly ipVersion?: string;
}
export declare function lbNetworkLoadBalancerListenerExternalAddressSpecToTerraform(struct?: LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference | LbNetworkLoadBalancerListenerExternalAddressSpec): any;
export declare class LbNetworkLoadBalancerListenerExternalAddressSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): LbNetworkLoadBalancerListenerExternalAddressSpec | undefined;
    set internalValue(value: LbNetworkLoadBalancerListenerExternalAddressSpec | undefined);
    private _address?;
    get address(): string;
    set address(value: string);
    resetAddress(): void;
    get addressInput(): string | undefined;
    private _ipVersion?;
    get ipVersion(): string;
    set ipVersion(value: string);
    resetIpVersion(): void;
    get ipVersionInput(): string | undefined;
}
export interface LbNetworkLoadBalancerListenerInternalAddressSpec {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#address LbNetworkLoadBalancer#address}
    */
    readonly address?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#ip_version LbNetworkLoadBalancer#ip_version}
    */
    readonly ipVersion?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#subnet_id LbNetworkLoadBalancer#subnet_id}
    */
    readonly subnetId: string;
}
export declare function lbNetworkLoadBalancerListenerInternalAddressSpecToTerraform(struct?: LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference | LbNetworkLoadBalancerListenerInternalAddressSpec): any;
export declare class LbNetworkLoadBalancerListenerInternalAddressSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): LbNetworkLoadBalancerListenerInternalAddressSpec | undefined;
    set internalValue(value: LbNetworkLoadBalancerListenerInternalAddressSpec | undefined);
    private _address?;
    get address(): string;
    set address(value: string);
    resetAddress(): void;
    get addressInput(): string | undefined;
    private _ipVersion?;
    get ipVersion(): string;
    set ipVersion(value: string);
    resetIpVersion(): void;
    get ipVersionInput(): string | undefined;
    private _subnetId?;
    get subnetId(): string;
    set subnetId(value: string);
    get subnetIdInput(): string | undefined;
}
export interface LbNetworkLoadBalancerListener {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#name LbNetworkLoadBalancer#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#port LbNetworkLoadBalancer#port}
    */
    readonly port: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#protocol LbNetworkLoadBalancer#protocol}
    */
    readonly protocol?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#target_port LbNetworkLoadBalancer#target_port}
    */
    readonly targetPort?: number;
    /**
    * external_address_spec block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#external_address_spec LbNetworkLoadBalancer#external_address_spec}
    */
    readonly externalAddressSpec?: LbNetworkLoadBalancerListenerExternalAddressSpec;
    /**
    * internal_address_spec block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#internal_address_spec LbNetworkLoadBalancer#internal_address_spec}
    */
    readonly internalAddressSpec?: LbNetworkLoadBalancerListenerInternalAddressSpec;
}
export declare function lbNetworkLoadBalancerListenerToTerraform(struct?: LbNetworkLoadBalancerListener | cdktf.IResolvable): any;
export interface LbNetworkLoadBalancerTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#create LbNetworkLoadBalancer#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#delete LbNetworkLoadBalancer#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer#update LbNetworkLoadBalancer#update}
    */
    readonly update?: string;
}
export declare function lbNetworkLoadBalancerTimeoutsToTerraform(struct?: LbNetworkLoadBalancerTimeoutsOutputReference | LbNetworkLoadBalancerTimeouts | cdktf.IResolvable): any;
export declare class LbNetworkLoadBalancerTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): LbNetworkLoadBalancerTimeouts | undefined;
    set internalValue(value: LbNetworkLoadBalancerTimeouts | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer yandex_lb_network_load_balancer}
*/
export declare class LbNetworkLoadBalancer extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_lb_network_load_balancer";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/lb_network_load_balancer yandex_lb_network_load_balancer} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options LbNetworkLoadBalancerConfig = {}
    */
    constructor(scope: Construct, id: string, config?: LbNetworkLoadBalancerConfig);
    get createdAt(): string;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get id(): string;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _regionId?;
    get regionId(): string;
    set regionId(value: string);
    resetRegionId(): void;
    get regionIdInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _attachedTargetGroup?;
    get attachedTargetGroup(): LbNetworkLoadBalancerAttachedTargetGroup[] | cdktf.IResolvable;
    set attachedTargetGroup(value: LbNetworkLoadBalancerAttachedTargetGroup[] | cdktf.IResolvable);
    resetAttachedTargetGroup(): void;
    get attachedTargetGroupInput(): cdktf.IResolvable | LbNetworkLoadBalancerAttachedTargetGroup[] | undefined;
    private _listener?;
    get listener(): LbNetworkLoadBalancerListener[] | cdktf.IResolvable;
    set listener(value: LbNetworkLoadBalancerListener[] | cdktf.IResolvable);
    resetListener(): void;
    get listenerInput(): cdktf.IResolvable | LbNetworkLoadBalancerListener[] | undefined;
    private _timeouts;
    get timeouts(): LbNetworkLoadBalancerTimeoutsOutputReference;
    putTimeouts(value: LbNetworkLoadBalancerTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): LbNetworkLoadBalancerTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=lb-network-load-balancer.d.ts.map