import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface MdbElasticsearchClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#deletion_protection MdbElasticsearchCluster#deletion_protection}
    */
    readonly deletionProtection?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#description MdbElasticsearchCluster#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#environment MdbElasticsearchCluster#environment}
    */
    readonly environment: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#folder_id MdbElasticsearchCluster#folder_id}
    */
    readonly folderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#labels MdbElasticsearchCluster#labels}
    */
    readonly labels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#name MdbElasticsearchCluster#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#network_id MdbElasticsearchCluster#network_id}
    */
    readonly networkId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#security_group_ids MdbElasticsearchCluster#security_group_ids}
    */
    readonly securityGroupIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#service_account_id MdbElasticsearchCluster#service_account_id}
    */
    readonly serviceAccountId?: string;
    /**
    * config block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#config MdbElasticsearchCluster#config}
    */
    readonly config: MdbElasticsearchClusterConfigA;
    /**
    * host block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#host MdbElasticsearchCluster#host}
    */
    readonly host?: MdbElasticsearchClusterHost[] | cdktf.IResolvable;
    /**
    * maintenance_window block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#maintenance_window MdbElasticsearchCluster#maintenance_window}
    */
    readonly maintenanceWindow?: MdbElasticsearchClusterMaintenanceWindow;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#timeouts MdbElasticsearchCluster#timeouts}
    */
    readonly timeouts?: MdbElasticsearchClusterTimeouts;
}
export interface MdbElasticsearchClusterConfigDataNodeResources {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#disk_size MdbElasticsearchCluster#disk_size}
    */
    readonly diskSize: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#disk_type_id MdbElasticsearchCluster#disk_type_id}
    */
    readonly diskTypeId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#resource_preset_id MdbElasticsearchCluster#resource_preset_id}
    */
    readonly resourcePresetId: string;
}
export declare function mdbElasticsearchClusterConfigDataNodeResourcesToTerraform(struct?: MdbElasticsearchClusterConfigDataNodeResourcesOutputReference | MdbElasticsearchClusterConfigDataNodeResources): any;
export declare class MdbElasticsearchClusterConfigDataNodeResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbElasticsearchClusterConfigDataNodeResources | undefined;
    set internalValue(value: MdbElasticsearchClusterConfigDataNodeResources | undefined);
    private _diskSize?;
    get diskSize(): number;
    set diskSize(value: number);
    get diskSizeInput(): number | undefined;
    private _diskTypeId?;
    get diskTypeId(): string;
    set diskTypeId(value: string);
    get diskTypeIdInput(): string | undefined;
    private _resourcePresetId?;
    get resourcePresetId(): string;
    set resourcePresetId(value: string);
    get resourcePresetIdInput(): string | undefined;
}
export interface MdbElasticsearchClusterConfigDataNode {
    /**
    * resources block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#resources MdbElasticsearchCluster#resources}
    */
    readonly resources: MdbElasticsearchClusterConfigDataNodeResources;
}
export declare function mdbElasticsearchClusterConfigDataNodeToTerraform(struct?: MdbElasticsearchClusterConfigDataNodeOutputReference | MdbElasticsearchClusterConfigDataNode): any;
export declare class MdbElasticsearchClusterConfigDataNodeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbElasticsearchClusterConfigDataNode | undefined;
    set internalValue(value: MdbElasticsearchClusterConfigDataNode | undefined);
    private _resources;
    get resources(): MdbElasticsearchClusterConfigDataNodeResourcesOutputReference;
    putResources(value: MdbElasticsearchClusterConfigDataNodeResources): void;
    get resourcesInput(): MdbElasticsearchClusterConfigDataNodeResources | undefined;
}
export interface MdbElasticsearchClusterConfigMasterNodeResources {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#disk_size MdbElasticsearchCluster#disk_size}
    */
    readonly diskSize: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#disk_type_id MdbElasticsearchCluster#disk_type_id}
    */
    readonly diskTypeId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#resource_preset_id MdbElasticsearchCluster#resource_preset_id}
    */
    readonly resourcePresetId: string;
}
export declare function mdbElasticsearchClusterConfigMasterNodeResourcesToTerraform(struct?: MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference | MdbElasticsearchClusterConfigMasterNodeResources): any;
export declare class MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbElasticsearchClusterConfigMasterNodeResources | undefined;
    set internalValue(value: MdbElasticsearchClusterConfigMasterNodeResources | undefined);
    private _diskSize?;
    get diskSize(): number;
    set diskSize(value: number);
    get diskSizeInput(): number | undefined;
    private _diskTypeId?;
    get diskTypeId(): string;
    set diskTypeId(value: string);
    get diskTypeIdInput(): string | undefined;
    private _resourcePresetId?;
    get resourcePresetId(): string;
    set resourcePresetId(value: string);
    get resourcePresetIdInput(): string | undefined;
}
export interface MdbElasticsearchClusterConfigMasterNode {
    /**
    * resources block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#resources MdbElasticsearchCluster#resources}
    */
    readonly resources: MdbElasticsearchClusterConfigMasterNodeResources;
}
export declare function mdbElasticsearchClusterConfigMasterNodeToTerraform(struct?: MdbElasticsearchClusterConfigMasterNodeOutputReference | MdbElasticsearchClusterConfigMasterNode): any;
export declare class MdbElasticsearchClusterConfigMasterNodeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbElasticsearchClusterConfigMasterNode | undefined;
    set internalValue(value: MdbElasticsearchClusterConfigMasterNode | undefined);
    private _resources;
    get resources(): MdbElasticsearchClusterConfigMasterNodeResourcesOutputReference;
    putResources(value: MdbElasticsearchClusterConfigMasterNodeResources): void;
    get resourcesInput(): MdbElasticsearchClusterConfigMasterNodeResources | undefined;
}
export interface MdbElasticsearchClusterConfigA {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#admin_password MdbElasticsearchCluster#admin_password}
    */
    readonly adminPassword: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#edition MdbElasticsearchCluster#edition}
    */
    readonly edition?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#plugins MdbElasticsearchCluster#plugins}
    */
    readonly plugins?: string[];
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#version MdbElasticsearchCluster#version}
    */
    readonly version?: string;
    /**
    * data_node block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#data_node MdbElasticsearchCluster#data_node}
    */
    readonly dataNode: MdbElasticsearchClusterConfigDataNode;
    /**
    * master_node block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#master_node MdbElasticsearchCluster#master_node}
    */
    readonly masterNode?: MdbElasticsearchClusterConfigMasterNode;
}
export declare function mdbElasticsearchClusterConfigAToTerraform(struct?: MdbElasticsearchClusterConfigAOutputReference | MdbElasticsearchClusterConfigA): any;
export declare class MdbElasticsearchClusterConfigAOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbElasticsearchClusterConfigA | undefined;
    set internalValue(value: MdbElasticsearchClusterConfigA | undefined);
    private _adminPassword?;
    get adminPassword(): string;
    set adminPassword(value: string);
    get adminPasswordInput(): string | undefined;
    private _edition?;
    get edition(): string;
    set edition(value: string);
    resetEdition(): void;
    get editionInput(): string | undefined;
    private _plugins?;
    get plugins(): string[];
    set plugins(value: string[]);
    resetPlugins(): void;
    get pluginsInput(): string[] | undefined;
    private _version?;
    get version(): string;
    set version(value: string);
    resetVersion(): void;
    get versionInput(): string | undefined;
    private _dataNode;
    get dataNode(): MdbElasticsearchClusterConfigDataNodeOutputReference;
    putDataNode(value: MdbElasticsearchClusterConfigDataNode): void;
    get dataNodeInput(): MdbElasticsearchClusterConfigDataNode | undefined;
    private _masterNode;
    get masterNode(): MdbElasticsearchClusterConfigMasterNodeOutputReference;
    putMasterNode(value: MdbElasticsearchClusterConfigMasterNode): void;
    resetMasterNode(): void;
    get masterNodeInput(): MdbElasticsearchClusterConfigMasterNode | undefined;
}
export interface MdbElasticsearchClusterHost {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#assign_public_ip MdbElasticsearchCluster#assign_public_ip}
    */
    readonly assignPublicIp?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#name MdbElasticsearchCluster#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#subnet_id MdbElasticsearchCluster#subnet_id}
    */
    readonly subnetId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#type MdbElasticsearchCluster#type}
    */
    readonly type: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#zone MdbElasticsearchCluster#zone}
    */
    readonly zone: string;
}
export declare function mdbElasticsearchClusterHostToTerraform(struct?: MdbElasticsearchClusterHost | cdktf.IResolvable): any;
export interface MdbElasticsearchClusterMaintenanceWindow {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#day MdbElasticsearchCluster#day}
    */
    readonly day?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#hour MdbElasticsearchCluster#hour}
    */
    readonly hour?: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#type MdbElasticsearchCluster#type}
    */
    readonly type: string;
}
export declare function mdbElasticsearchClusterMaintenanceWindowToTerraform(struct?: MdbElasticsearchClusterMaintenanceWindowOutputReference | MdbElasticsearchClusterMaintenanceWindow): any;
export declare class MdbElasticsearchClusterMaintenanceWindowOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbElasticsearchClusterMaintenanceWindow | undefined;
    set internalValue(value: MdbElasticsearchClusterMaintenanceWindow | undefined);
    private _day?;
    get day(): string;
    set day(value: string);
    resetDay(): void;
    get dayInput(): string | undefined;
    private _hour?;
    get hour(): number;
    set hour(value: number);
    resetHour(): void;
    get hourInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export interface MdbElasticsearchClusterTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#create MdbElasticsearchCluster#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#delete MdbElasticsearchCluster#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster#update MdbElasticsearchCluster#update}
    */
    readonly update?: string;
}
export declare function mdbElasticsearchClusterTimeoutsToTerraform(struct?: MdbElasticsearchClusterTimeoutsOutputReference | MdbElasticsearchClusterTimeouts | cdktf.IResolvable): any;
export declare class MdbElasticsearchClusterTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbElasticsearchClusterTimeouts | undefined;
    set internalValue(value: MdbElasticsearchClusterTimeouts | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster yandex_mdb_elasticsearch_cluster}
*/
export declare class MdbElasticsearchCluster extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_mdb_elasticsearch_cluster";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/mdb_elasticsearch_cluster yandex_mdb_elasticsearch_cluster} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options MdbElasticsearchClusterConfig
    */
    constructor(scope: Construct, id: string, config: MdbElasticsearchClusterConfig);
    get createdAt(): string;
    private _deletionProtection?;
    get deletionProtection(): boolean | cdktf.IResolvable;
    set deletionProtection(value: boolean | cdktf.IResolvable);
    resetDeletionProtection(): void;
    get deletionProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _environment?;
    get environment(): string;
    set environment(value: string);
    get environmentInput(): string | undefined;
    private _folderId?;
    get folderId(): string;
    set folderId(value: string);
    resetFolderId(): void;
    get folderIdInput(): string | undefined;
    get health(): string;
    get id(): string;
    private _labels?;
    get labels(): {
        [key: string]: string;
    };
    set labels(value: {
        [key: string]: string;
    });
    resetLabels(): void;
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _networkId?;
    get networkId(): string;
    set networkId(value: string);
    get networkIdInput(): string | undefined;
    private _securityGroupIds?;
    get securityGroupIds(): string[];
    set securityGroupIds(value: string[]);
    resetSecurityGroupIds(): void;
    get securityGroupIdsInput(): string[] | undefined;
    private _serviceAccountId?;
    get serviceAccountId(): string;
    set serviceAccountId(value: string);
    resetServiceAccountId(): void;
    get serviceAccountIdInput(): string | undefined;
    get status(): string;
    private _config;
    get config(): MdbElasticsearchClusterConfigAOutputReference;
    putConfig(value: MdbElasticsearchClusterConfigA): void;
    get configInput(): MdbElasticsearchClusterConfigA | undefined;
    private _host?;
    get host(): MdbElasticsearchClusterHost[] | cdktf.IResolvable;
    set host(value: MdbElasticsearchClusterHost[] | cdktf.IResolvable);
    resetHost(): void;
    get hostInput(): cdktf.IResolvable | MdbElasticsearchClusterHost[] | undefined;
    private _maintenanceWindow;
    get maintenanceWindow(): MdbElasticsearchClusterMaintenanceWindowOutputReference;
    putMaintenanceWindow(value: MdbElasticsearchClusterMaintenanceWindow): void;
    resetMaintenanceWindow(): void;
    get maintenanceWindowInput(): MdbElasticsearchClusterMaintenanceWindow | undefined;
    private _timeouts;
    get timeouts(): MdbElasticsearchClusterTimeoutsOutputReference;
    putTimeouts(value: MdbElasticsearchClusterTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): MdbElasticsearchClusterTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=mdb-elasticsearch-cluster.d.ts.map