import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface MdbKafkaConnectorConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#cluster_id MdbKafkaConnector#cluster_id}
    */
    readonly clusterId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#name MdbKafkaConnector#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#properties MdbKafkaConnector#properties}
    */
    readonly properties?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#tasks_max MdbKafkaConnector#tasks_max}
    */
    readonly tasksMax?: number;
    /**
    * connector_config_mirrormaker block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#connector_config_mirrormaker MdbKafkaConnector#connector_config_mirrormaker}
    */
    readonly connectorConfigMirrormaker?: MdbKafkaConnectorConnectorConfigMirrormaker[] | cdktf.IResolvable;
}
export interface MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#bootstrap_servers MdbKafkaConnector#bootstrap_servers}
    */
    readonly bootstrapServers: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#sasl_mechanism MdbKafkaConnector#sasl_mechanism}
    */
    readonly saslMechanism?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#sasl_password MdbKafkaConnector#sasl_password}
    */
    readonly saslPassword?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#sasl_username MdbKafkaConnector#sasl_username}
    */
    readonly saslUsername?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#security_protocol MdbKafkaConnector#security_protocol}
    */
    readonly securityProtocol?: string;
}
export declare function mdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalClusterToTerraform(struct?: MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster | cdktf.IResolvable): any;
export interface MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster {
}
export declare function mdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisClusterToTerraform(struct?: MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster | cdktf.IResolvable): any;
export interface MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#alias MdbKafkaConnector#alias}
    */
    readonly alias?: string;
    /**
    * external_cluster block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#external_cluster MdbKafkaConnector#external_cluster}
    */
    readonly externalCluster?: MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster[] | cdktf.IResolvable;
    /**
    * this_cluster block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#this_cluster MdbKafkaConnector#this_cluster}
    */
    readonly thisCluster?: MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster[] | cdktf.IResolvable;
}
export declare function mdbKafkaConnectorConnectorConfigMirrormakerSourceClusterToTerraform(struct?: MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference | MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster): any;
export declare class MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster | undefined;
    set internalValue(value: MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster | undefined);
    private _alias?;
    get alias(): string;
    set alias(value: string);
    resetAlias(): void;
    get aliasInput(): string | undefined;
    private _externalCluster?;
    get externalCluster(): MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster[] | cdktf.IResolvable;
    set externalCluster(value: MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster[] | cdktf.IResolvable);
    resetExternalCluster(): void;
    get externalClusterInput(): cdktf.IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterExternalCluster[] | undefined;
    private _thisCluster?;
    get thisCluster(): MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster[] | cdktf.IResolvable;
    set thisCluster(value: MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster[] | cdktf.IResolvable);
    resetThisCluster(): void;
    get thisClusterInput(): cdktf.IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerSourceClusterThisCluster[] | undefined;
}
export interface MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#bootstrap_servers MdbKafkaConnector#bootstrap_servers}
    */
    readonly bootstrapServers: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#sasl_mechanism MdbKafkaConnector#sasl_mechanism}
    */
    readonly saslMechanism?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#sasl_password MdbKafkaConnector#sasl_password}
    */
    readonly saslPassword?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#sasl_username MdbKafkaConnector#sasl_username}
    */
    readonly saslUsername?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#security_protocol MdbKafkaConnector#security_protocol}
    */
    readonly securityProtocol?: string;
}
export declare function mdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalClusterToTerraform(struct?: MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster | cdktf.IResolvable): any;
export interface MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster {
}
export declare function mdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisClusterToTerraform(struct?: MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster | cdktf.IResolvable): any;
export interface MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#alias MdbKafkaConnector#alias}
    */
    readonly alias?: string;
    /**
    * external_cluster block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#external_cluster MdbKafkaConnector#external_cluster}
    */
    readonly externalCluster?: MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster[] | cdktf.IResolvable;
    /**
    * this_cluster block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#this_cluster MdbKafkaConnector#this_cluster}
    */
    readonly thisCluster?: MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster[] | cdktf.IResolvable;
}
export declare function mdbKafkaConnectorConnectorConfigMirrormakerTargetClusterToTerraform(struct?: MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference | MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster): any;
export declare class MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster | undefined;
    set internalValue(value: MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster | undefined);
    private _alias?;
    get alias(): string;
    set alias(value: string);
    resetAlias(): void;
    get aliasInput(): string | undefined;
    private _externalCluster?;
    get externalCluster(): MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster[] | cdktf.IResolvable;
    set externalCluster(value: MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster[] | cdktf.IResolvable);
    resetExternalCluster(): void;
    get externalClusterInput(): cdktf.IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterExternalCluster[] | undefined;
    private _thisCluster?;
    get thisCluster(): MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster[] | cdktf.IResolvable;
    set thisCluster(value: MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster[] | cdktf.IResolvable);
    resetThisCluster(): void;
    get thisClusterInput(): cdktf.IResolvable | MdbKafkaConnectorConnectorConfigMirrormakerTargetClusterThisCluster[] | undefined;
}
export interface MdbKafkaConnectorConnectorConfigMirrormaker {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#replication_factor MdbKafkaConnector#replication_factor}
    */
    readonly replicationFactor: number;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#topics MdbKafkaConnector#topics}
    */
    readonly topics: string;
    /**
    * source_cluster block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#source_cluster MdbKafkaConnector#source_cluster}
    */
    readonly sourceCluster: MdbKafkaConnectorConnectorConfigMirrormakerSourceCluster;
    /**
    * target_cluster block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector#target_cluster MdbKafkaConnector#target_cluster}
    */
    readonly targetCluster: MdbKafkaConnectorConnectorConfigMirrormakerTargetCluster;
}
export declare function mdbKafkaConnectorConnectorConfigMirrormakerToTerraform(struct?: MdbKafkaConnectorConnectorConfigMirrormaker | cdktf.IResolvable): any;
/**
* Represents a {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector yandex_mdb_kafka_connector}
*/
export declare class MdbKafkaConnector extends cdktf.TerraformResource {
    static readonly tfResourceType = "yandex_mdb_kafka_connector";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/yandex/r/mdb_kafka_connector yandex_mdb_kafka_connector} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options MdbKafkaConnectorConfig
    */
    constructor(scope: Construct, id: string, config: MdbKafkaConnectorConfig);
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    get clusterIdInput(): string | undefined;
    get id(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _properties?;
    get properties(): {
        [key: string]: string;
    };
    set properties(value: {
        [key: string]: string;
    });
    resetProperties(): void;
    get propertiesInput(): {
        [key: string]: string;
    } | undefined;
    private _tasksMax?;
    get tasksMax(): number;
    set tasksMax(value: number);
    resetTasksMax(): void;
    get tasksMaxInput(): number | undefined;
    private _connectorConfigMirrormaker?;
    get connectorConfigMirrormaker(): MdbKafkaConnectorConnectorConfigMirrormaker[] | cdktf.IResolvable;
    set connectorConfigMirrormaker(value: MdbKafkaConnectorConnectorConfigMirrormaker[] | cdktf.IResolvable);
    resetConnectorConfigMirrormaker(): void;
    get connectorConfigMirrormakerInput(): cdktf.IResolvable | MdbKafkaConnectorConnectorConfigMirrormaker[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
//# sourceMappingURL=mdb-kafka-connector.d.ts.map